/**************************************************************************
Check VGA BIOS for a given text string

0.1	First version
0.2	added known magic words:
	Tseng,PARADISE,Video Seven,TRIDENT,Video-7
0.3	include possibility to dump VGA BIOS + "Sigma" magic word
	+ removed checking for VGA + BNF Usage info
0.4	documentation and upload to Garbo

Dr. Dobb's Journal #166 July 1990 Super VGA Programming
by Christopher A. Howard

NOTE: has to be compiled in LARGE memory model to make MK_FP to work
	pc/a/c/e/f-/j/ml/s/w checkvga	(Power C)

Jouni Miettunen * jon@stekt.oulu.fi * Oulu * Finland * Europe * 1993
***************************************************************************/

#include <stdio.h>	/* puts, printf */
#include <dos.h>	/* MK_FP */
#define ID "Jouni Miettunen * jon@stekt.oulu.fi * Oulu * Finland * Europe * 1993\n"
#define VERSION	"0.4"

/* main ******************************************************************/
/* top level interface to the program ************************************/
/*************************************************************************/
int main(int argc, char **argv)
{
register char		*a;
register char far	*b,*c;
register int		i;

if (argc==2 &&
	(argv[1][0]=='l' && argv[1][1]=='\0') ||
	((argv[1][0]=='-' || argv[1][0]=='\\' || argv[1][0]=='/') &&
		argv[1][1]=='l' && argv[1][2]=='\0')) {
			c = MK_FP(0xC000,0);		/* VGA BIOS c000:0000 */
			puts("Listing 500 first VGA BIOS characters:\n");
			for (i=0; i<500; i++) putchar(*c++);
		}

if (argc!=2) {
	puts("Check VGA BIOS (about first 500 bytes) for a given text string "VERSION);
	puts(ID);
	puts("Set DOS Errorlevel to 1 if found, else 0.");
	puts("Usage: <checkvga> [ text_string | -l ]\n");
	puts("-l\tlist first 500 bytes from VGA BIOS\n");
	puts("Known Magic text strings:");
	puts("\t\"Tseng\", \"PARADISE\", \"Video Seven\", \"TRIDENT\", \"Video-7\", \"Sigma\"\n");
/*	puts("To find the text string to look for, do this:");
	puts("\tdebug\t\t(start the debug program, You have on disk)");
	puts("\td c000:0,100\t(dump 256 bytes from VGA BIOS start C000:0000)");
	puts("\tq\t\t(quit the debug program)\n");
	puts("Now check the manufacturer's name from the copyright notice.");
*/	puts("This program is Freeware, free to use and distribute. Enjoy!\n");
	puts("References:\tDr.Dobb's Journal #166 July 1990");
	puts("\t\tSuperVGA Programming by Christopher A. Howard");
	return (0);
}

a = argv[1];			/* first char to search */
c = MK_FP(0xC000,0);		/* VGA BIOS c000:0000 */

for (i=0; i<500; i++) {
	if (*a==*c++) {
		b = c;
		++a;
		while (*a && (*++a == *++b));
		if (!*a) {printf("Found \"%s\"\n",argv[1]); return (1);}
		else a = argv[1];
	}
}
printf("Not found \"%s\"\n",argv[1]); return (0);

} /*int main*/

/*************************************************************************/
/***************************** A HAPPY END *******************************/
/*************************************************************************/
